
#include "drawmaps.h"
#include <pixrect/pixrect_hs.h>
#include <rasterfile.h>

#define X_LO	77.3
#define X_HI	77.9
#define Y_LO	42.9
#define Y_HI	43.4
#define SCRN_X	1024
#define SCRN_Y	800
#define OP	(PIX_SRC|PIX_DST|PIX_COLOR(1))
#define XPT(x)	((int)(SCRN_X-((((x)-X_LO)/(X_HI-X_LO))*SCRN_X)))
#define YPT(x)	((int)((((x)-Y_LO)/(Y_HI-Y_LO))*SCRN_Y))

int value,show_links=0;
char buf[MAXSTRSIZE];
struct entry *host_list,*host_tail,*frag;
struct pixrect *pr;
struct pixfont *font,*fontB;
FILE *fp;

main(argc,argv)
	int argc;char**argv;{
	struct pr_prpos where;
	int i=1;

	if ((argc>1)&&(argv[1][0]=='-')){
		/* args */
		if (argv[1][1]=='x')show_links=1;
		i++;
	}
	fp = fopen("/tmp/mapout.ras","w");
	pr = mem_create(SCRN_X,SCRN_Y,1);
	font =pf_open("/usr/lib/fonts/fixedwidthfonts/screen.r.7");
	fontB=pf_open("/usr/lib/fonts/fixedwidthfonts/serif.r.16");

	where.pr = pr;
	where.pos.x = SCRN_X/2-112;
	where.pos.y = SCRN_Y-34;

	pf_text(where,OP,fontB,"Rochester Area UUCP Connectivity");
	where.pos.x = SCRN_X-224;
	where.pos.y = SCRN_Y-24;
	pf_text(where,OP,font,"Created by: Jeff Weisberg");

	host_list=host_tail=get_entry();
	while(1){
		host_tail->next = get_entry();
		host_tail = host_tail->next;
		host_tail->next = 0;
	}
}



draw_map(){
	struct entry *host;
	struct connection *conn;

	/* save frag */
	if ( frag != host_tail){
		host_tail->next=frag;
		host_tail=frag;
	}
	/* later sort host list */
	/* init graphics */

	host = host_list;
	do{
		put_dot(host->name,host->lng,host->lat,host->size);
		draw_lines(host->lng,host->lat,host->neighbors);
		host=host->next;
	}while (host);
	/* output the map */

	if (pr_dump(pr,fp,0,1,1)){
		fprintf(stderr,"Could not dump pixrect\n");
	}
	fclose(fp);

	exit(0);

}

draw_lines(lng,lat,head)
	float lng,lat;
	struct connection *head;{
	struct connection *conn=head;
	struct entry *host;

	if (!conn)return;
	do{
		host=find_host(conn->name);
		if (host)
			put_line(lng,lat,host->lng,host->lat,host->name);
			conn = conn->next;

	}while( conn);
}

struct entry *find_host(name)
	char*name;{
	struct entry *host;

	host=host_list;
	while(host&&( strcmp(name,host->name)) ){
		host=host->next;
	}
	return(host);
}

put_dot(name,x,y,size)
	char *name;
	float x,y;
	int size;{
	struct pr_prpos where;

	where.pr = pr;
	where.pos.x = XPT(x);
	where.pos.y = YPT(y);

	pf_text(where,OP,font,name);

#ifdef DEBUG
	printf("%s(%f,%f)\n",name,x,y); 
#endif
}
put_line(xi,yi,xf,yf,name)
	float xi,yi,xf,yf;
	char *name;{

#define IN_RANGE(x) ( (x)>1 )

	if ( ! IN_RANGE(xi))return;
	if ( ! IN_RANGE(xf))return;
	if ( ! IN_RANGE(yi))return;
	if ( ! IN_RANGE(yf))return;

	pr_vector(pr,XPT(xi),YPT(yi),XPT(xf),YPT(yf),OP,1);
}
